--  Create_Synonyms v. 1.0
--
--  This script generates a list (or script, if spooled) of "create
--  synonym" statements. It must be run under a user with DBA rights,
--  and has been tested under Oracle version 8.1.7. Note that
--  synonyms or tables owned by SYS or SYSTEM are excluded from the
--  output, and that the output is sorted by TABLE_OWNER and TABLE_NAME.
--
-- 
--                                          W. S. Pollack
--                                          01/2003
--                                          bill@billanddot.com
--                                          http://www.billanddot.com/downloads.htm
--
--
set verify off
set termout off
set feedback off
set echo off
set pagesize 0
set linesize 76
set trims on
set space 0
set recsep off
--
column nl newline
--
select '-- ================================ --' nl,
       '--  "Create_Synonyms" Version 1.0   --' nl,
       '--                                  --' nl,
       '-- ' ||
--           lpad(' ', 6-ceil(length(trim(NAME))/2)) || trim(NAME) ||
             lpad(' ',16-ceil(length(trim(NAME))/2)) || trim(NAME) ||
--           ', ' || to_char(SYSDATE,'MM/DD/YYYY @ HH24:MI') ||
--           lpad(' ', 6-floor(length(trim(NAME))/2)) ||
             lpad(' ',16-floor(length(trim(NAME))/2)) ||
                                          ' --' nl,
       '-- ================================ --' nl,
       ' ' nl
from V$DATABASE
;
select 'create synonym ' || OWNER       || '.' || SYNONYM_NAME,
       'for            ' || TABLE_OWNER || '.' || TABLE_NAME nl,
       ';' nl
from   DBA_SYNONYMS
where  OWNER       not in ('SYS','SYSTEM')
and    TABLE_OWNER not in ('SYS','SYSTEM')
order  by TABLE_OWNER, TABLE_NAME, OWNER, SYNONYM_NAME
;
